import io.reactivex.Observable;
import io.reactivex.Observer;
import io.reactivex.Scheduler;
import io.reactivex.disposables.Disposable;
import io.reactivex.functions.Consumer;
import io.reactivex.internal.schedulers.SchedulerWhen;

import javax.annotation.Resource;

public class HelloRX{

    public static void main(String[] args) {

        Observable<UserMessage> observable = new Observable<UserMessage>() {
            @Override
            protected void subscribeActual(Observer<? super UserMessage> observer) {
                UserMessage us1 = new UserMessage("zhangSan","hello");
                UserMessage us2 = new UserMessage("liSi","rxJava");
                UserMessage us3 = new UserMessage("wangWu","end");

                observer.onNext(us1);
                observer.onNext(us2);
                observer.onNext(us3);
            }
        };

        Consumer<UserMessage> consumer = new Consumer<UserMessage>() {
            public void accept(UserMessage userMessage) throws Exception {
                String message = userMessage.getMessage();
                String userName = userMessage.getUserName();
                System.out.println("用户:"+userName+",说了一句:"+message);
            }
        };

        System.out.println("-----------------------------");

        Test<UserMessage> test = new Test<UserMessage>() {
            @Override
            protected String test1(Test2<? super UserMessage> var) {
                UserMessage userMessage = new UserMessage("wjz","wjz");
                return var.sayHello(userMessage);
            }
        };

        System.out.println(test.test1(new Test2<UserMessage>()));
    }
}
